'use strict';
// フラグ変数
// ON/OFFを設定するためのボタン
// 呼び方 var a=new TwoStateButtonbutton("ボタン表示領域のid",現在値,変更された時に呼び出す関数,ON時ラベル,OFF時ラベル);
// 最後のOFF時ラベルが省略された時は、ON時ラベルに（現在ON）、（現在OFF）をつけたものを生成する。
// 例：
// <p><span id="g">ON/OFF表示領域</span></p>
//	<script>
//	 var gflg=new TwoStateButton("g",false,function (x) { ps.drawFFlg=x;},"力の表示ON/OFF（現在ON）","力の表示ON/OFF（現在OFF）");
//	</script>
// 実行されると、<span id="g">ON/OFF表示領域</span>の部分が
// <input type="button" id="g_button">
// に書き換えられる（どうせ書き換えられるので、最初の文字列は空文でも可）。
// 最後の引数である「変更された時に呼び出す関数」は、上のように無名関数を記入してもよいし、他のところで定義した
// 関数の名前を書いてもよい。関数の引数には、ONになったかOFFになったかの論理値が入って呼び出される。
var TwoStateButton = function (id_string, val, func, ontime_string, offtime_string, ontime_color, offtime_color) {
    if (ontime_string === undefined) {
        ontime_string = "フラグ";
    }
	if (offtime_string === undefined) {
		this.ontime_string = ontime_string + "（現在ON）";
        this.offtime_string = ontime_string + "（現在OFF）";
	} else {
        this.ontime_string = ontime_string;
        this.offtime_string = offtime_string;
    }
    this.ontime_color = (ontime_color === undefined) ? "#E87" : ontime_color;
    this.offtime_color = (offtime_color === undefined) ? "#228" : offtime_color;
    document.getElementById(id_string).innerHTML='<input type="button" id="' + id_string + '_flg_button" class="twostate">';
    this.button=document.getElementById(id_string + "_flg_button");

	this.value = (val !== undefined) ? val : false;
    

    if (this.value) {
        this.setON();
    } else {
        this.setOFF();
    }
	if (func !== undefined) {
		this.onchangefunc = func;
	}
	var vs = this;
	this.button.onclick = function () {
		vs.onchange();
	};
};
TwoStateButton.prototype = {
	getValue: function () { return this.button.value; },
    setValue: function (x) {
        if (x === true) {
            this.setON();
        }
        if (x === false) {
            this.setOFF();
        }
    },
	setON: function () {
        this.value = true;
        this.button.value = this.ontime_string;
        this.button.style.color=this.ontime_color;
    },
    setOFF: function () {
        this.value = false;
        this.button.value = this.offtime_string;
        this.button.style.color=this.offtime_color;
    },
	onchange: function () {
		if (this.value) {
            this.setOFF();
        } else {
            this.setON();
        }
        this.onchangefunc(this.value);
	},
	onchangefunc: function () {} // 何もしないスタブ。
};
